-- Load Variables
if type(INSraid) ~= "boolean" then
	INSraid = false;
else
end
if type(INSparty) ~= "boolean" then
	INSparty = false;
else
end
if type(INSsay) ~= "boolean" then
	INSsay = true;
else
end

if type(INSself) ~= "boolean" then
 INSself = true;
else
end

if type(INSspell) ~= "boolean" then
 INSspell = true;
else
end

if type(INStarget) ~= "boolean" then
 INStarget = true;
else
end

if type(INScompact) ~= "boolean" then
 INScompact = true;
else
end


-- Define Event Action
function OnEventINS(self, event, ...)

	if ( event == "PLAYER_ENTERING_WORLD" ) then
		self:UnregisterEvent("PLAYER_ENTERING_WORLD");
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	elseif ( event == "COMBAT_LOG_EVENT_UNFILTERED" ) then
		local numParty	= GetNumGroupMembers();
		local timeStamp, eventType, sourceName, sourceFlags, destName, destRaidFlags, spellID, _, extraSpellID;
		if CombatLogGetCurrentEventInfo then
			timeStamp, eventType, _, _, sourceName, sourceFlags, _, _, destName, _, destRaidFlags, spellID, _, _, extraSpellID = CombatLogGetCurrentEventInfo()
		end
		
		if (eventType == "SPELL_INTERRUPT") and (sourceName == UnitName("pet") or sourceName == UnitName("player")) then 
			local intmsg = ("Interrupted");
			local inInstance, instanceType = IsInInstance();
			if(INScompact == true) and (INStarget == true) then
				intmsg = (intmsg.." "..destName)
				if(INSspell == true) then
					intmsg = (intmsg.."'s "..GetSpellLink(extraSpellID))
				end				
			else
				if(INSspell == true) then
					intmsg = (intmsg.." "..GetSpellLink(extraSpellID))
				end
				if(INStarget == true) then
					if(INSspell == true) then
						intmsg = (intmsg.." of "..destName)
					else
						intmsg = (intmsg.." "..destName)
					end
				end
			end

			local partysendalready = false;
			
			if UnitInParty("player") and (INSparty == true) and (numParty > 0) then
				SendChatMessage(intmsg, IsPartyLFG() and "INSTANCE_CHAT" or "PARTY")
				partysendalready = true;
			end
			if UnitInRaid("player") and (INSraid == true) and (partysendalready == false) then
				SendChatMessage(intmsg, IsPartyLFG() and "INSTANCE_CHAT" or "RAID")
			end
			if (INSsay == true and inInstance) then
				SendChatMessage(intmsg, "SAY")
			end
			if (INSself == true) then
				print(intmsg)
			end
		end
	end;
end

-- Register Event
local InterruptNoSpam = CreateFrame("Frame")
InterruptNoSpam:RegisterEvent("PLAYER_ENTERING_WORLD")
InterruptNoSpam:SetScript("OnEvent", OnEventINS)

-- Configuration Frame
local mainFrame = CreateFrame("Frame", "InterruptNoSpam", InterfaceOptionsFramePanelContainer);
mainFrame.name = "InterruptNoSpam";
mainFrame:Hide();
mainFrame:SetScript("OnShow", function(frame)

	local INStitle = frame:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge");
	INStitle:SetText("InterruptNoSpam");
	INStitle:SetPoint("TOPLEFT", 16, -16);

	local INSauthor = frame:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	INSauthor:SetText("by Xavstrasza@EU-Alexstrasza");
	INSauthor:SetPoint("TOPLEFT", 16, -36);
	
	local INSversion = frame:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	INSversion:SetText("v1.8.3");
	INSversion:SetPoint("TOPLEFT", 16, -56);
	
	local myselfonoff = CreateFrame("CheckButton", "myselfonoff", frame, "InterfaceOptionsCheckButtonTemplate")
	local myselfFunc = function(self, value) INSself = value end
	myselfonoff:SetScript("OnClick", function(self)
		myselfFunc(self, self:GetChecked() and true or false)
	end)
	myselfonoff:SetChecked(INSself)
	_G[myselfonoff:GetName() .. "Text"]:SetText("To myself")
	myselfonoff:SetPoint("CENTER", frame, "LEFT", 30, -30)
	
	
	local sayonoff = CreateFrame("CheckButton", "sayonoff", frame, "InterfaceOptionsCheckButtonTemplate")
	local sayFunc = function(self, value) INSsay = value end
	sayonoff:SetScript("OnClick", function(self)
		sayFunc(self, self:GetChecked() and true or false)
	end)
	sayonoff:SetChecked(INSsay)
	_G[sayonoff:GetName() .. "Text"]:SetText("Via say (only works in instances!)")
	sayonoff:SetPoint("CENTER", frame, "LEFT", 30, 0)


	
	local partyonoff = CreateFrame("CheckButton", "partyonoff", frame, "InterfaceOptionsCheckButtonTemplate")
	local partyFunc = function(self, value) INSparty = value end
	partyonoff:SetScript("OnClick", function(self)
		partyFunc(self, self:GetChecked() and true or false)
	end)
	partyonoff:SetChecked(INSparty)
	_G[partyonoff:GetName() .. "Text"]:SetText("Send to party")
	partyonoff:SetPoint("CENTER", frame, "LEFT", 30, 30)
	
	
	
	local raidonoff = CreateFrame("CheckButton", "raidonoff", frame, "InterfaceOptionsCheckButtonTemplate")
	local raidFunc = function(self, value) INSraid = value end
	raidonoff:SetScript("OnClick", function(self)
		raidFunc(self, self:GetChecked() and true or false)
	end)
	raidonoff:SetChecked(INSraid)
	_G[raidonoff:GetName() .. "Text"]:SetText("Send to raid")
	raidonoff:SetPoint("CENTER", frame, "LEFT", 30, 60)
	
	
	local spellonoff = CreateFrame("CheckButton", "spellonoff", frame, "InterfaceOptionsCheckButtonTemplate")
	local spellFunc = function(self, value) INSspell = value end
	spellonoff:SetScript("OnClick", function(self)
		spellFunc(self, self:GetChecked() and true or false)
	end)
	spellonoff:SetChecked(INSspell)
	_G[spellonoff:GetName() .. "Text"]:SetText("Include what spell you interrupted in the message.")
	spellonoff:SetPoint("CENTER", frame, "LEFT", 30, 90)

	local targetonoff = CreateFrame("CheckButton", "targetonoff", frame, "InterfaceOptionsCheckButtonTemplate")
	local targetFunc = function(self, value) INStarget = value end
	targetonoff:SetScript("OnClick", function(self)
		targetFunc(self, self:GetChecked() and true or false)
	end)
	targetonoff:SetChecked(INStarget)
	_G[targetonoff:GetName() .. "Text"]:SetText("Include who you interrupted in the message.")
	targetonoff:SetPoint("CENTER", frame, "LEFT", 30, 120)
	
	
	local compactonoff = CreateFrame("CheckButton", "compactonoff", frame, "InterfaceOptionsCheckButtonTemplate")
	local compactFunc = function(self, value) INScompact = value end
	compactonoff:SetScript("OnClick", function(self)
		compactFunc(self, self:GetChecked() and true or false)
	end)
	compactonoff:SetChecked(INScompact)
	_G[compactonoff:GetName() .. "Text"]:SetText("A little more compact message, if both target and spellname are displayed.")
	compactonoff:SetPoint("CENTER", frame, "LEFT", 30, 150)
	
	
	mainFrame:SetScript("OnShow", nil)
end)	



InterfaceOptions_AddCategory(mainFrame);
